﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Linq;
using System.Text;
using System.Windows.Forms;
using dotnetCHARTING.WinForms;
using System.Runtime.InteropServices;
using System.Drawing.Printing;
using System.IO;
using System.Drawing.Imaging;
using System.Threading;
using mgh;
namespace Personal
{
    public partial class frm_chart : Form
    {
#region Graphic

        string sql_;
        ConnectionClass con = new ConnectionClass();
        private System.IO.Stream streamToPrint;
        string streamType;
        string Title_Chart = "";
        [System.Runtime.InteropServices.DllImportAttribute("gdi32.dll")]
        private static extern bool BitBlt
            (
                IntPtr hdcDest,
                int nXDest,
                int nYDest,
                int nWidth,
                int nHeights,
                IntPtr hdcSrc,
                int nXSrc,
                int nYSrc,
                System.Int32 dwRop
             );
#endregion
        public frm_chart(string sql_statument,string TitleChart)
        {
            InitializeComponent();
            sql_ = sql_statument;
            printDocument1.PrintPage += new PrintPageEventHandler(printDocument1_PrintPage);
            Title_Chart=TitleChart;
        }
        private void Show_Chart()
        {
            try
            {
                chart1.Height = chart1.Height--;
                chart1.Width = chart1.Width--;
                chart1.PrinterOptimizedText = true;
                chart1.TitleBox.Label.Text = Title_Chart;
                chart1.ShadingEffectMode = ShadingEffectMode.Six;
                chart1.SeriesCollection.Clear();
                chart1.Use3D = true;
                chart1.DefaultSeries.ConnectionString = con.ConnectionString;
                chart1.DateGrouping = TimeInterval.Month;
                chart1.Series.SqlStatement = sql_;
                chart1.Series.Type = SeriesType.Column;
                chart1.SeriesCollection.Add();
            }
            catch
            {
                MessageBox.Show("خطایی در داده ها برای  تهیه گزارش رخ داده است", "خطای گزارش", MessageBoxButtons.OK, MessageBoxIcon.Information);
            }
        }
        private void printDocument1_PrintPage(System.Object sender, System.Drawing.Printing.PrintPageEventArgs e)
        {
            System.Drawing.Image image = System.Drawing.Image.FromStream(this.streamToPrint);
            int x = e.MarginBounds.X;
            int y = e.MarginBounds.Y;
            int width = image.Width;
            int height = image.Height;
            if ((width / e.MarginBounds.Width) > (height / e.MarginBounds.Height))
            {
                width = e.MarginBounds.Width;
                height = image.Height * e.MarginBounds.Width / image.Width;
            }
            else
            {
                height = e.MarginBounds.Height;
                width = image.Width * e.MarginBounds.Height / image.Height;
            }
            System.Drawing.Rectangle destRect = new System.Drawing.Rectangle(x, y, width, height);
            e.Graphics.DrawImage(image, destRect, 0, 0, image.Width, image.Height, System.Drawing.GraphicsUnit.Pixel);
        }
        public void StartPrint(Stream streamToPrint, string streamType)
        {
            this.printDocument1.PrintPage += new PrintPageEventHandler(printDocument1_PrintPage);
            this.streamToPrint = streamToPrint;
            this.streamType = streamType;
            System.Windows.Forms.PrintDialog printDialog1 = new PrintDialog();
            printDialog1.AllowSomePages = true;
            printDialog1.ShowHelp = true;
            printDialog1.Document = printDocument1;
            DialogResult result = printDialog1.ShowDialog();
            if (result == DialogResult.OK)
            {
                printDocument1.Print();

            }

        }
        private void چاپنمودارToolStripMenuItem_Click(object sender, EventArgs e)
        {
            string  path ;
            if (MessageBox.Show("آیا گزارش مورد نظر ثبت وچاپ شود؟", "ثبت گزارش", MessageBoxButtons.YesNo, MessageBoxIcon.Information) == DialogResult.Yes)
            {
                SaveFileDialog sfd = new SaveFileDialog();
                sfd.InitialDirectory = Environment.SpecialFolder.Desktop.ToString();
                sfd.Filter = "ُSave Report (*.jpg)|*.JPG|All files (*.JPG)|*.JPG";
                sfd.FileName = "IsoChart";
                sfd.RestoreDirectory = true;
                sfd.ShowDialog();
                path = sfd.FileName.ToString();
                Thread.Sleep(50);
                Graphics g1 = this.CreateGraphics();
                Image MyImage = new Bitmap(this.ClientRectangle.Width, this.ClientRectangle.Height, g1);
                Graphics g2 = Graphics.FromImage(MyImage);
                IntPtr dc1 = g1.GetHdc();
                IntPtr dc2 = g2.GetHdc();
                BitBlt(dc2, 0, 0, this.ClientRectangle.Width, this.ClientRectangle.Height, dc1, 0, 0, 13369376);
                g1.ReleaseHdc(dc1);
                g2.ReleaseHdc(dc2);
                MyImage.Save(@path, System.Drawing.Imaging.ImageFormat.Jpeg);
                FileStream filestream = new FileStream(@path, FileMode.Open, FileAccess.Read);
                StartPrint(filestream, "Image");
                FarsiMessagbox.Show("گزارش به صورت عکس در مسیر فوق زخیره شد" + "\n" + sfd.FileName, "ذخیره گزارش", FMessageBoxButtons.Ok, FMessageBoxIcon.Information);

            }

        }
        private void frm_Iso_Report_Load(object sender, EventArgs e)
        {
            Show_Chart();
        }



    }
}
